var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};

// src/useQuery.ts
import { useHistory, useLocation } from "react-router";
import { parse, stringify } from "query-string";
var useQuery = (initialValue, stripValues = [void 0, null, "", 0, "0"]) => {
  const history = useHistory();
  const queryString = useLocation().search;
  const query = __spreadValues(__spreadValues({}, initialValue), parse(queryString));
  const updateQuery = (state) => {
    const newQueryString = stringify(pickBy(state, (value) => !stripValues.includes(value)));
    history.push({ search: newQueryString });
  };
  const setQuery = (state) => updateQuery(state);
  const patchQuery = (state) => updateQuery(__spreadValues(__spreadValues({}, query), state));
  return [query, setQuery, patchQuery];
};
var pickBy = (object, predicate) => {
  return Object.keys(object).reduce((accumulator, key) => {
    const value = object[key];
    if (predicate(value)) {
      accumulator[key] = value;
    }
    return accumulator;
  }, {});
};
export {
  useQuery
};
//# sourceMappingURL=index.js.map
